import Head from "next/head";
import { useEffect, useReducer } from "react";
import { fetchFaqData } from "@/utils/api/faq";
import { fetchBestDealsData } from "@/utils/api/bestDeals";
import Script from "next/script";
import HeroBanner from "@/components/rendering/heroBanner";
import WhyWaoSim from "@/components/rendering/whyWaoSim";
import UnlimitedEsim from "@/components/rendering/unlimitedEsim";
import SupportedCountries from "@/components/rendering/supportedCountries";
import BestDeals from "@/components/rendering/bestDeals";
import AboutEsim from "@/components/rendering/aboutEsim";
import CustomerSupport from "@/components/rendering/customerSupport";
import NewsArticals from "@/components/rendering/newsArticals";
import FrequetlyAskedQuestion from "@/components/rendering/frequentlyAskedQuestion";
import EsimConnectivity from "@/components/rendering/esimConnectivity";
import OurVideo from "@/components/rendering/ourVideo";

// Define action types
const ActionTypes = {
  SET_HOME_FAQ_DATA: "SET_HOME_FAQ_DATA",
  SET_BEST_DEALS_DATA: "SET_BEST_DEALS_DATA",
};

// Define the initial state
const initialState = {
  homeFaqData: null,
  bestDealsData: null,
};

// Define the reducer function
function reducer(state: any, action: any) {
  switch (action.type) {
    case ActionTypes.SET_HOME_FAQ_DATA:
      return { ...state, homeFaqData: action.payload };
    case ActionTypes.SET_BEST_DEALS_DATA:
      return { ...state, bestDealsData: action.payload };
    default:
      return state;
  }
}

async function fetchData(dispatch: any) {
  try {
    let payload = {
      status: 1,
    };
    const { isError, response } = await fetchFaqData(payload);

    dispatch({ type: ActionTypes.SET_HOME_FAQ_DATA, payload: response });
  } catch (error) {
    console.error(error);
  }
}

async function fetchDataBestDeals(dispatch: any) {
  try {
    const { isError, response } = await fetchBestDealsData();

    dispatch({
      type: ActionTypes.SET_BEST_DEALS_DATA,
      payload: response?.data?.popular_deals,
    });
  } catch (error) {
    console.error(error);
  }
}

export default function HomePage() {
  const [state, dispatch] = useReducer(reducer, initialState);

  useEffect(() => {
    fetchData(dispatch);
    fetchDataBestDeals(dispatch);
  }, [dispatch]);
  const { homeFaqData, bestDealsData } = state;

  return (
    <>
      <Head>
        <title>WaoSim</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />

        <meta
          property="og:image"
          content="https://stagecdn.waosim.com/landingpage/thumbnail.png?v=1"
        />
        <link rel="icon" href="/faviconIcon.svg" />
      </Head>

      <Script
        type="module"
        src="https://widget.guidy.co/v1/assets/static/injector.js"
        data-account="HFBBNed8efTWhrh"
        integrity="uqN3eEppvUKDwMQX9JdvhYlWqcmg8VeWzHBuyFjYTvZAwShyF1GXshOf84yXZ91j"
        crossOrigin="anonymous"
        onLoad={() => console.log("first Script has loaded")}
      ></Script>

      <main>
        <HeroBanner />
        <WhyWaoSim />
        <UnlimitedEsim />
        <SupportedCountries />
        <BestDeals data={bestDealsData} />
        <AboutEsim />
        <CustomerSupport />
        <NewsArticals />
        <FrequetlyAskedQuestion data={homeFaqData} />
        <EsimConnectivity />
        <OurVideo />
      </main>
    </>
  );
}

// export async function getServerSideProps({ req }: any) {
//   const { isError, response } = await getAllCountryRegion();

//   return {
//     props: {
//       response: response?.data,
//     },
//   };
// }
